/***************************************************************************
                          lmsensorswidget.cpp  -  description
                             -------------------
    begin                : Mon Aug 6 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qobject.h>
#include <qpixmap.h>
#include <qtimer.h>
#include <qevent.h>
#include <qicon.h>
#include <qapplication.h>
#include <qdebug.h>

#include <kaboutdata.h>

#include "general.h"
#include "lmsensorscfg.h"
#include "lmsensorswidget.h"


/***************************************************************************
 *  Public methods                                                         *
 ***************************************************************************/

LMSensorsWidget::LMSensorsWidget(sensorDevsGroups *lsensors,QWidget *parent, const QString &name ) : QWidget( parent, Qt::WindowStaysOnTopHint /* ,name */)
{
    Q_UNUSED(name);
  
/*   WStyle_Customize | WStyle_StaysOnTop | WStyle_NormalBorder | */
//  setWindowFlags( Qt::Widget );
    setAttribute( Qt::WA_DeleteOnClose );  

    sysPanels = nullptr;
    qlMess = nullptr;
  
    gaugeSize = chartWidth = chartHeight = 64;
 
 setMinimumSize(0,0);
/* setSizeIncrement(64,64);
 setBaseSize(64,64); */
 //
 sensors= lsensors;
 //
 childDraging = nullptr;
 //
 const KAboutData kadAboutData = KAboutData::applicationData();
 
 setWindowTitle( kadAboutData.displayName() );
 //
 windowsSolid = true;
 qpmBackGround = QPixmap ( findIcon ("ksensorsbackground.png") );
 qpLMSensorsWidget = palette();
 loadPalette();

//    setSizeIncrement( 64, 64 );
//    setBaseSize( 64, 64);
 //

    setGroupConf ( qsFL1( "ShowWidget" ) );
    QRect rect = getEntryConf ( qsFL1( "geometry" ) , QRect(), ksensorsSetting::AutoDefault );

    qlMess = new QLabel ( this );
    qlMess->setDisabled ( true );
    qlMess->setMargin( 5 );
    qlMess->setWordWrap ( true );
    qlMess->setText( qsFL1( "In this panels window or in panels docked to the system tray" ) + QLatin1String( "<br>" ) + qsFL1( "Right click for Configure and Save Configuration and other." ) + QLatin1String( "<br>" ) + QLatin1String( "<br>" ) + qsFL1 ( "Left clik on panels docked to the system tray for open/close panels window." ) );
    

    qlMess->resize( rect.size() );

    move( rect.topLeft() );
    resize( rect.size() );

    loadGeneralOptions( true );

 // 
// setBackgroundPixmap( QPixmap( findIcon ("ksensorsbackground.png") ) ); 
 //
  
 //
 createSensorPanels();
 //
 
// make windowHandle() find struct QTLWExtra -> QWidgetWindow *window not set to zero
  WId wiForSetIncr = winId();
  Q_UNUSED(wiForSetIncr);
/*  qtResize.setSingleShot(true);
  connect(&qtResize, SIGNAL(timeout()), this, SLOT(resizeDone())); */

}

LMSensorsWidget::~LMSensorsWidget()
{  
  saveGeometry();
}

void LMSensorsWidget::updateWidget ( const QString &name, bool withChange )
{
    bool withShow;
    
    QString qsShowType;

    if ( !name.isEmpty() && name != qsFL1( "General" ) )
    {
        Panel *panel= findChild<Panel *>(name);
        Sensor *sensor= sensors->getSensor(name);

        if( sensor )
        {
//          setGroupConf ( name );
            setSensorDevGroupConf ( sensor->getShortName(), sensor->getLongName(), sensor->getSubName() );

            qsShowType = getEntryConf ( qsFL1( "show" ), qsFL1( "false" ), ksensorsSetting::AutoDefault );

            withShow = qsShowType != qsFL1( "false" );

            if ( withShow != (bool)panel )
                withChange = true;

          if ( withChange ) 
          {
              if(panel) 
                  delete panel; 
            
              if ( withShow )
                (void)new SensorPanel( sensor, this, sensor->getLongName() );
          }
      } 

      panel= findChild<Panel *>(name);
    if(panel) loadPalette(panel);
    } 
    else 
    {
    loadPalette();
    loadGeneralOptions( false );
    }
}

// ******************* Protected Q_SLOTS ******************************


/* bool LMSensorsWidget::event(QEvent *event)
{
//    qDebug() << "\033[91m" << "qDebug(): LMSensorsWidget::event event->type()" << event->type() <<"\033[0m";
  
    switch (event->type())
    {
//    case QEvent::NonClientAreaMouseButtonRelease:
    case QEvent::Resize:
//        if (event->spontaneous()) return false;   
    case QEvent::UpdateRequest:
        qtResize.stop();
        qtResize.start(500);

        break;          
    default:
      
      break;
    }
  
  return QWidget::event (event);
}

void LMSensorsWidget::resizeDone()
{
    QSize qsResize, qsSnap, qsObj;
    QRect qrGeom;
  
    qsResize = size();    
    qsSnap.setWidth(int((qsResize.width() / 64.0) + 0.5) * 64.0);
    qsSnap.setHeight(int((qsResize.height() / 64.0) + 0.5) * 64.0);

//    if (qsSnap != qsResize)
    {
      resize(qsResize.width(), qsResize.height() -1);
      resize(qsSnap);
    }
} */


/***************************************************************************
 * Private methods                                                         *
 ***************************************************************************/

void LMSensorsWidget::childEvent(QChildEvent *e)
{
    if (e->added()) 
    {
        Panel *panel = qobject_cast<Panel *>( e->child() );
      
        loadDisplayConfig( /* (Panel *)e->child() */ panel );
    }
}

// ************* Draging panels and show menu ************************

void LMSensorsWidget::childEventReceived(QEvent *e)
{
QMouseEvent *m = (QMouseEvent*)e;

 switch(e->type()) {
  case QEvent::MouseButtonPress:

      if( m->button()==Qt::LeftButton ) startDragChild(m,(QWidget *)sender());
      break;

  case QEvent::MouseButtonRelease:

      if( m->button()==Qt::RightButton ) Q_EMIT rightMouseClicked(m);
      break;
  default:
    
    break;
 }
}


void LMSensorsWidget::startDragChild(QMouseEvent *m, QWidget *w)
{
	if(childDraging == nullptr )
	{
		childDraging= w;    
		grabMouse(Qt::SizeAllCursor);
#if (QT_VERSION < QT_VERSION_CHECK(6, 0, 0))
		origMousePt = w->mapFromGlobal(m->globalPos());
#else
                origMousePt = w->mapFromGlobal(m->globalPosition().toPoint());
#endif
		//w->move( m->globalPos()-mapToGlobal(QPoint(0,0))-origMousePt);
		w->raise();
		w->update();
	}
}

void LMSensorsWidget::endDragChild()
{
    int meterWitdhSize, meterHeightSize, meterX, meterY;

int x= childDraging->x();
int y= childDraging->y();

 if(x<0) x=0;
 if(y<0) y=0;
 releaseMouse();

/*  meterWitdhSize = gaugeSize;
    meterHeightSize = gaugeSize;

    meterX = ((x+childDraging->width() /2) / meterWitdhSize) * meterWitdhSize;
    meterY = ((y+childDraging->height()/2) / meterHeightSize) * meterHeightSize; */


    meterWitdhSize = getPar ( qsFL1( "incrwidthsizeglob" ), gaugeSize );
    meterHeightSize = getPar ( qsFL1( "incrheightsizeglob" ), gaugeSize );

    meterX = ( ( x + meterWitdhSize / 2 ) / meterWitdhSize ) * meterWitdhSize;
    meterY = ( ( y + meterHeightSize / 2 ) / meterHeightSize ) * meterHeightSize;

qDebug() << "\033[91m" << "qDebug(): LMSensorsWidget::endDragChild() " << meterX << meterY <<"\033[0m";

 childDraging->move( meterX, meterY );
 
 saveDisplayConfig((Panel *)childDraging);
 childDraging= nullptr;
}

void LMSensorsWidget::mouseMoveEvent ( QMouseEvent *m )
{
	if(childDraging) 
	{ 
		childDraging->move(m->pos()-origMousePt);
		childDraging->update(); 
	}
}


void LMSensorsWidget::mouseReleaseEvent ( QMouseEvent *m )
{
 if(childDraging && m->button()==Qt::LeftButton)  endDragChild();
 else
   if(m->button()==Qt::RightButton) Q_EMIT rightMouseClicked(m);
}

// ********************** Panels creation ************************

void LMSensorsWidget::findUnusedPosition(int *px,int *py)
{
    int meterWitdhSize, meterHeightSize;

bool found;
uint mx,my,x,y,a[32];

    meterWitdhSize = getPar ( qsFL1( "incrwidthsizeglob" ), gaugeSize );
    meterHeightSize = getPar ( qsFL1( "incrheightsizeglob" ), gaugeSize );

  const QObjectList *list= &children();

 for(y=0; y<32; y++) a[y]= 0;
 mx= 0; my= 0;
 if(list)
 {
    for ( QObjectList::ConstIterator it = list->begin(); it != list->end(); ++it )       
    {
      QWidget *obj = (QWidget *)(*it);      
       
       if ( obj )
       {

       y=obj->y() / gaugeSize /* meterWitdhSize */ ;
       x=obj->x() / gaugeSize /* meterHeightSize */ ;
       if(x<32 && y<32) a[y]|=  (1 << x);
       if(x>mx) mx= x;
       if(y>my) my= y;
       
       }
       else
         break;
      
    }
 
 }
 //
 for(x=0,y=0,found=false;y<=my && !found;) {
   found= ((a[y] & (1 << x))==0);
   if(!found)
     if(++x>mx) { x= 0; y++; }
 }

 if(!found) {
    x= (width()-1) / gaugeSize /* meterWitdhSize */;
    if(x>mx) { x= mx+1; y= 0;    }
    else     { x= 0;    y= my+1; }
 }
 //
 *px= x;
 *py= y;
}

void LMSensorsWidget::loadDisplayConfig(Panel *display)
{
    int meterWitdhSize, meterHeightSize;

 if( display == nullptr ) return;

    meterWitdhSize = getPar ( qsFL1( "incrwidthsizeglob" ), gaugeSize );
    meterHeightSize = getPar ( qsFL1( "incrheightsizeglob" ), gaugeSize );

 loadPalette(display);

 bool fNoCfg;
 QPoint p;
 
    Sensor *sensor= sensors->getSensor( display->objectName() );
//  setGroupConf ( display->objectName() );
    setSensorDevGroupConf ( sensor->getShortName(), sensor->getLongName(), sensor->getSubName() );
    p = getEntryConf ( qsFL1( "showPos" ) , QPoint(), ksensorsSetting::AutoDefault );
 
 fNoCfg= (p.x()<0 || p.y()<0);
 if(fNoCfg) findUnusedPosition(&p.rx(),&p.ry());

    display->move(p.x()*gaugeSize,p.y()*gaugeSize);
//    display->move(p.x() * meterWitdhSize, p.y() * meterHeightSize);

  display->resizePanel ( gaugeSize, chartWidth, chartHeight );
 
 display->show();
 if(fNoCfg) {
    saveDisplayConfig(display);
    adjustSize();
 }
 display->installEventFilter(this);
 connect(display, SIGNAL(eventReceived(QEvent *)), this, SLOT(childEventReceived(QEvent *)) );
}

void LMSensorsWidget::saveDisplayConfig(Panel *display)
{
    int meterWitdhSize, meterHeightSize;

    meterWitdhSize = getPar ( qsFL1( "incrwidthsizeglob" ), gaugeSize );
    meterHeightSize = getPar ( qsFL1( "incrheightsizeglob" ), gaugeSize );


 setGroupConf ( display->objectName() );
 setEntryConf ( qsFL1( "show" ) , display->getShowType() );

    QPoint p= display->pos()/gaugeSize;
//    QPoint p = QPoint ( display->pos().x() / meterWitdhSize, display->pos().y() / meterHeightSize ) ;
 
 setEntryConf ( qsFL1( "showPos" ) ,p);
}


void LMSensorsWidget::createSensorPanels()
{
    QString qsShowType;
    
 const QObjectList *chips= sensors->getSensorsChips();
 if(chips)
 {
    for ( QObjectList::ConstIterator it = chips->begin(); it != chips->end(); ++it )       
    {
      SensorsList *chip = (SensorsList *)(*it);
       
      if ( chip )
      {
        if ( chip->getClass() == Sensor::sysSensor )
          sysPanels = (SYSSensorsList *)chip;
        
       QObjectList *list= (QObjectList *)chip->getSensors();
       if(list) 
       {
          for ( QObjectList::ConstIterator it = list->begin(); it != list->end(); ++it )       
          {
            LMSensor *sensor = (LMSensor *)(*it);
       
            if ( sensor )
            {
//              setGroupConf ( sensor->objectName() );
                setSensorDevGroupConf ( sensor->getShortName(), sensor->getLongName(), sensor->getSubName() );
                qsShowType = getEntryConf ( qsFL1( "show" ), qsFL1( "false" ), ksensorsSetting::AutoDefault );

                if ( qsShowType != qsFL1( "false" ) )
                    (void) new SensorPanel(sensor, this, sensor->getLongName() );
            }
            else
              break;
            
           }
       }
      }
      else
        break;
      
    }
    
 }
}

void LMSensorsWidget::updatePanels()
{
    bool enabSize;
    int newGaugeSize, newChartWidth, newChartHeight;

    setGroupConf ( qsFL1( "ShowWidget" )  );
    newGaugeSize = getEntryConf ( qsFL1( "PanelsSize" ) , -1, ksensorsSetting::AutoDefault );
    newChartWidth = getEntryConf ( qsFL1( "chartWidth" ) , -1, ksensorsSetting::AutoDefault );
    newChartHeight = getEntryConf ( qsFL1( "chartHeight" ) , -1, ksensorsSetting::AutoDefault );

  const QObjectList *panels= &children();

  enabSize = false;

  if (gaugeSize != newGaugeSize || chartWidth != newChartWidth || chartHeight != newChartHeight ) 
  {
      int sizeIncrWitdh, sizeIncrHeight;
      
      sizeIncrWitdh = getPar ( qsFL1( "incrwidthsizeglob" ), newGaugeSize ); 
      sizeIncrHeight = getPar ( qsFL1( "incrheightsizeglob" ), newGaugeSize );

      setSizeIncrement( sizeIncrWitdh, sizeIncrHeight );
      setBaseSize ( sizeIncrWitdh, sizeIncrHeight );

    enabSize = true;
  }
    
  if ( panels )
  {
    for ( QObjectList::ConstIterator it = panels->begin(); it != panels->end(); ++it )       
    {
//      Panel *panel = (Panel *)(*it);
      Panel *panel = qobject_cast<Panel *>( *it );
      QWidget *qwPanel = (QWidget *)(*it);
       
      if ( panel )
      {
      
      if ( qwPanel )
      {

        if ( enabSize )
        {
          qwPanel->move( (qwPanel->x()/gaugeSize)*newGaugeSize, (qwPanel->y()/gaugeSize)*newGaugeSize);
          
          /* qwPanel */ panel->resizePanel ( newGaugeSize, newChartWidth, newChartHeight );
        }
      
        loadPalette ( panel ) ;
      }
      else
        break;
        
      }
      
    }      
  } // if ( panels )
   
  if ( enabSize )
  {
    gaugeSize = newGaugeSize;
    chartWidth = newChartWidth;
    chartHeight = newChartHeight;
	
    adjustSize();
  }
} // void updatePanels()


void LMSensorsWidget::saveGeometry()
{
  QRect geometry ( pos(), size() );
  
  if ( !(geometry.x() >= 0 && geometry.y() >= 0) )
  {
    geometry.setX( 0 );
    geometry.setY( 0 );
  }

  setGroupConf ( qsFL1( "ShowWidget" )  );
  setEntryConf ( qsFL1( "geometry" ) , geometry );

//  void LMSensorsWidget::cfgWriteGeometry( QRect geometry )

}

void LMSensorsWidget::loadGeneralOptions( bool enabForce )
{
  bool newWindowsSolid;
  double windowsOpacityValue;
  
  setGroupConf ( qsFL1( "ShowWidget" )  );
  newWindowsSolid = getEntryConf ( qsFL1( "windowsSolid" ) , false, ksensorsSetting::AutoDefault );
  windowsOpacityValue = getEntryConf ( qsFL1( "windowsOpacityValue" ) , -1.0, ksensorsSetting::AutoDefault );

  if ( newWindowsSolid != windowsSolid  || enabForce )
  {
    windowsSolid = newWindowsSolid;

    setAttribute( Qt::WA_TranslucentBackground, !windowsSolid );
    setAttribute( Qt::WA_NoSystemBackground, !windowsSolid );
    setWindowFlags( ( windowsSolid ? ( Qt::WindowStaysOnTopHint | Qt::WindowTitleHint ) : ( Qt::WindowStaysOnTopHint | Qt::FramelessWindowHint | Qt::Tool ) ) );

//    setVisible( true );
    show();
  }
  setWindowOpacity( ( windowsOpacityValue / 100.0 ) );


  updatePanels();
}

// ************************+******** Palettes stuff ****************************

void LMSensorsWidget::loadPalette(Panel *panel)
{
  QPalette pal = qpLMSensorsWidget;
  if(panel) 
  {
    if(getPalette(pal, panel->objectName() ,false)) 
      panel->setPalette(pal);
    else  
      panel->setPalette( qpLMSensorsWidget /* QPalette() */ );
    
    panel->updateFrame();
  } 
  else 
  {
    getPalette(pal, QString(), true);
    qpLMSensorsWidget = pal;
    setPalette(pal);
    pal.setBrush( backgroundRole(), QBrush( qpmBackGround ));    
    setPalette(pal);
  }
}

/* void LMSensorsWidget::setBackgroundPixmap( const QPixmap &qpmBackGround )
{  
  QPalette pal = palette();
  pal.setBrush( backgroundRole(), QBrush( qpmBackGround ));
  setPalette(pal);
} */
